<?php
// お絵かき掲示板システム
// (c) paisley 2017/03/01

$PAGESIZE = 20;						// １ページあたりの記事数
$SAVEDIR = 'save/';					// 投稿保存ディレクトリ
$COUNTER = $SAVEDIR . 'counter';	// 投稿カウンターファイル
$TEMPLATE = 'bbs.html';				// テンプレートファイル

$post = 0;
if (isset($_REQUEST['post'])) $post = $_REQUEST['post'];
$page = 0;
if (isset($_REQUEST['page'])) $page = $_REQUEST['page'];

switch ($post) {
case 0:		// 全体表示
	display();
	break;
case 1:		// レスの投稿を受け取る
	getResponse();
	break;
case 2:		// 画像の詳細情報入力画面を表示
	inputData();
	break;
case 3:		// 画像ファイルを受け取る
	getImage();
	break;
case 4:		// 画像の詳細情報を受け取る
	getContrib();
	break;
}

// 全体表示
function display() {
	global $PAGESIZE;
	global $SAVEDIR;
	global $COUNTER;
	global $TEMPLATE;
	global $page;

	// クッキーからデフォルトの名前を用意
	$name = '';
	if (isset($_COOKIE['name'])) $name = $_COOKIE['name'];

	// テンプレートを読み込む
	$temp = file_get_contents($TEMPLATE);
	// ここでは入力フォームは要らないので撤去
	$temp = preg_replace('/<!-- input -->.*<!-- input end -->/s', '', $temp);
	// データ置き換え
	$temp = str_replace('__NEW__', 'visible', $temp);
	$temp = str_replace('__NAME__', $name, $temp);
	$temp = str_replace('__NOW_PAGE__', $page, $temp);

	// 記事に相当する部分を切り抜き
	$findArticle = '/<!-- article -->(.*)<!-- article end -->/s';
	preg_match($findArticle, $temp, $p);
	$atemp = $p[1];

	// 現在のカウンター
	$counter = file_get_contents($COUNTER);

	// 表示する最初の投稿ナンバー
	$start = $counter - $page * $PAGESIZE;

	// 表示する分だけ記事を構築
	$allArticle = '';
	for ($no = $start; $no >= 0 && $no > $start - $PAGESIZE; $no--) {
		$file = $SAVEDIR . $no;
		// ファイルがなければ無視
		if (!file_exists($file)) continue;
		// テキストファイルを読み込む
		$contents = file($file);
		// 最初の行は投稿詳細情報
		$am = explode("\t", $contents[0]);	// タブ区切りになっている
		$article = $atemp;
		$article = str_replace('__NO__', $no, $article);
		$article = str_replace('__IMAGE__', $SAVEDIR . $no . '.png', $article);
		$article = str_replace('__AUTHER__', htmlspecialchars($am[0]), $article);
		$article = str_replace('__COMMENT__', htmlspecialchars($am[1]), $article);
		$article = str_replace('__POST_DATE__', $am[2], $article);

		// レスに相当する部分を切り抜き
		$findRes = '/<!-- res -->(.*)<!-- res end -->/s';
		preg_match($findRes, $article, $p);
		$rtemp = $p[1];

		// レスの分だけ構築
		$allRes = '';
		for ($rn = 1; $rn < count($contents); $rn++) {
			$rm = explode("\t", $contents[$rn]);	// タブ区切りになっている
			$res = $rtemp;
			$res = str_replace('__CNAME__', htmlspecialchars($rm[0]), $res);
			$res = str_replace('__RES_COMMENT__', htmlspecialchars($rm[1]), $res);
			$res = str_replace('__RES_DATE__', $rm[2], $res);
			$allRes .= $res;
		}
		// レスと記事を結合
		$article = preg_replace($findRes, $allRes, $article);
		$allArticle .= $article;
	}
	// 記事をテンプレートに結合
	$temp = preg_replace($findArticle, $allArticle, $temp);

	// ページャーに相当する部分を切り抜き
	$findPage = '/<!-- page -->(.*)<!-- page end -->/s';
	preg_match($findPage, $temp, $p);
	$ptemp = $p[1];

	// 全ページ分構築
	$pager = '';
	for ($pn = 0; $pn * $PAGESIZE < $counter; $pn++) {
		if ($pn == $page) {		// いま表示しているページは数字だけ
			$pager .= ($pn + 1) . ' ';
		} else {				// それ以外はリンクに
			$pd = $ptemp;
			$pd = str_replace('__PAGE__', $pn, $pd);
			$pd = str_replace('__PAGED__', $pn + 1, $pd);
			$pager .= $pd;
		}
	}
	// ページャーをテンプレートに結合
	$temp = preg_replace($findPage, $pager, $temp);
	// 出力
	print $temp;
}

// レスの投稿を受け取る
function getResponse() {
	global $SAVEDIR;

	$no = $_POST['no'];
	$name = str_replace(["\t","\n"], ' ', $_POST['name']);
	$comment = str_replace(["\t","\n"], ' ', $_POST['comment']);

	// 投稿ナンバーをもとにしたファイル名
	$file = $SAVEDIR . $no;
	if (file_exists($file)) {
		// 追記
		$fp = fopen($file, 'a');
		fputs($fp, $name . "\t" . $comment . "\t" . date("Y-m-d H:i:s") . "\t\n");
		fclose($fp);
		setcookie('name', $name);
	}
	reload();
}

// 画像の詳細情報を受け取る
function getContrib() {
	global $SAVEDIR;
	global $COUNTER;

	if (!isset($_POST['id'])) die('missing id');
	$id = $_POST['id'];

	// 投稿したばかりの画像ファイルはidをベースにしたファイル名
	$file = $SAVEDIR . $id . '.png';
	if (file_exists($file)) {

		// カウンターの更新
		$fp = fopen($COUNTER, 'r+');
		flock($fp, LOCK_EX);
		$counter = (int)fread($fp, filesize($COUNTER));
		$counter++;
		rewind($fp);
		fwrite($fp, $counter);

		// 本当の名前に変更
		rename($file, $SAVEDIR . $counter . '.png');

		// 詳細情報をもとにテキストデータを作る
		$fa = fopen($SAVEDIR . $counter, 'w');
		$name = str_replace(["\t","\n"], ' ', $_POST['name']);
		$comment = str_replace(["\t","\n"], ' ', $_POST['comment']);
		fputs($fa, $name . "\t" . $comment . "\t" . date("Y-m-d H:i:s") . "\t\n");
		fclose($fa);
		fclose($fp);
		setcookie('name', $name);
		reload();
	} else {
		die($file . ' not found');
	}
}

// 画像ファイルを受け取る
function getImage() {
	global $SAVEDIR;

	if (!isset($_GET['id'])) {error_log('missing id');die();}						// 失敗時は沈黙
	if (!isset($_FILES['file']['tmp_name'])) {error_log('missing file');die();}		// 失敗時は沈黙

	$id = $_GET['id'];
	$file = $SAVEDIR . $id . '.png';	// idをベースにファイル名を付ける

	if (copy($_FILES['file']['tmp_name'], $file)) {
		print('ok');	// お絵かきシステムにアップロード完了を知らせる
	}
	// 失敗時は沈黙
	error_log('cannot rename');
}

// 画像の詳細情報入力画面を表示
function inputData() {
	global $TEMPLATE;
	global $SAVEDIR;

	if (!isset($_GET['id'])) die('missing id');
	$id = $_GET['id'];

	$name = '';
	if (isset($_COOKIE['name'])) $name = $_COOKIE['name'];

	$temp = file_get_contents($TEMPLATE);
	$findArticle = '/<!-- article -->(.*)<!-- article end -->/s';
	$temp = preg_replace($findArticle, '', $temp);
	$findPage = '/<!-- page -->(.*)<!-- page end -->/s';
	$temp = preg_replace($findPage, '', $temp);

	$temp = str_replace('__NEW__', 'hidden', $temp);
	$temp = str_replace('__NAME__', $name, $temp);
	$temp = str_replace('__ID__', $id, $temp);
	$temp = str_replace('__POST_IMAGE__', $SAVEDIR . $id . '.png', $temp);

	print $temp;
}

// 全体を再読み込み
function reload() {
	global $page;

	if (isset($_SERVER['SSL_PROTOCOL'])) {
		$prot = 'https://';
	} else {
		$prot = 'http://';
	}
	$path = $_SERVER['SERVER_NAME'] . $_SERVER['SCRIPT_NAME'];
	header('Location: ' . $prot . $path . '?page=' . $page);

}
